<script setup lang="ts">
import type { User } from '@/types/User'
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const dialog = ref(false)
const loading = ref(false)
const form = ref(false)
const users = ref<User[]>([])
const refForm = ref<VForm | null>(null)
let myDate = new Date()

const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Full Name',
    key: 'fullName'
  },
  {
    title: 'Gender',
    key: 'gender'
  },
  {
    title: 'Email',
    key: 'email'
  },

  {
    title: 'Position',
    key: 'roles'
  },
  {
    title: 'LogIn Time',
    key: 'logintime'
  },
  {
    title: 'LogOut Time',
    key: 'logouttime'
  },
  {
    title: 'Date In',
    key: 'date',
    value: (Date: any | User) => Date.date.toLocaleDateString('en-GB')
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const dialogDelete = ref(false)
const initialUser: User = {
  id: -1,
  email: '',
  password: '',
  fullName: '',
  gender: 'Others',
  roles: 'Employee',
  logintime: '',
  logouttime: '',
  date: myDate
}

let editedIndex = -1
let lastId = 8

const page = ref(1)
const itemsPerPage = ref<any>(5)
const pageCount = computed(() => {
  return Math.ceil(users.value.length / itemsPerPage.value)
})
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
  })
}
function deleteItemConfirm() {
  users.value.splice(editedIndex, 1)
  closeDelete()
  editedIndex = -1
}

function editItem(item: User) {
  editedIndex = users.value.findIndex((p) => p.id === item.id)
  editedUser.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: User) {
  editedIndex = users.value.findIndex((p) => p.id === item.id)
  dialogDelete.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return

  if (editedIndex > -1) {
    Object.assign(users.value[editedIndex], editedUser.value)
  } else {
    editedUser.value.id = lastId
    lastId++
    users.value.push(editedUser.value)
  }
  editedIndex = -1
  closeDialog()
}

function initialize() {
  users.value = [
    {
      id: 1,
      email: 'ma1@gmail.com',
      password: 'pass',
      fullName: 'Sivat Rattanavong',
      gender: 'Male',
      roles: 'Manager',
      logintime: new Date().toLocaleTimeString('en-US', { hour12: false }),
      logouttime: '16:00:00',
      date: new Date()
    },

    {
      id: 2,
      email: 'ma2@gmail.com',
      password: 'pass',
      fullName: 'Tanakit Wongviroj',
      gender: 'Male',
      roles: 'Employee',
      logintime: '10:00:00',
      logouttime: '16:00:00',
      date: new Date('2024-01-13')
    },
    {
      id: 3,
      email: 'ma3@gmail.com',
      password: 'pass',
      fullName: 'Kornnisa Thongiam',
      gender: 'Female',
      roles: 'Manager',
      logintime: '11:20:00',
      logouttime: '16:00:00',
      date: new Date('2024-01-14')
    },
    {
      id: 4,
      email: 'ma4@gmail.com',
      password: 'pass',
      fullName: 'Jane Jajo',
      gender: 'Female',
      roles: 'Employee',
      logintime: '10:20:00',
      logouttime: '16:00:00',
      date: new Date('2024-01-12')
    },
    {
      id: 5,
      email: 'ma5@gmail.com',
      password: 'pass',
      fullName: 'Phu Fah',
      gender: 'Female',
      roles: 'Employee',
      logintime: '11:30:00',
      logouttime: '16:00:00',
      date: new Date('2024-01-11')
    },
    {
      id: 6,
      email: 'ma6@gmail.com',
      password: 'pass',
      fullName: 'Pare Lolipop',
      gender: 'Female',
      roles: 'Employee',
      logintime: '12:00:00',
      logouttime: '16:00:00',
      date: new Date('2024-01-11')
    },
    {
      id: 7,
      email: 'ma7@gmail.com',
      password: 'pass',
      fullName: 'Arm Koi',
      gender: 'Male',
      roles: 'Employee',
      logintime: '10:00:00',
      logouttime: '16:00:00',
      date: new Date('2024-01-12')
    }
  ]
}

onMounted(() => {
  initialize()
})

const search = ref<string>('')

const editedUser = ref<User>(JSON.parse(JSON.stringify(initialUser)))

const formattedProducts = computed(() =>
  users.value.map((user) => ({
    ...user
  }))
)
const filteredUsers = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedProducts.value.filter((product) =>
    product.fullName.toLowerCase().includes(searchLower)
  )
})
</script>

<template>
  <div>
    <div class="text-center">
      <h1 style="text-align: left" class="ml-5">USER MANAGEMENT</h1>
    </div>
    <div>
      <v-card-title class="d-flex align-center pe-2">
        <v-spacer></v-spacer>

        <v-dialog v-model="dialog" persistent width="1024">
          <v-card
            ><v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="12" md="4">
                      <v-text-field
                        v-model="editedUser.fullName"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        class="mb-2"
                        clearable
                        label="Full Name"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="12" md="4">
                      <v-text-field
                        v-model="editedUser.email"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        clearable
                        label="Username or Email"
                        placeholder="Enter your username"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="12" md="4">
                      <v-text-field
                        v-model="editedUser.password"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'required']"
                        clearable
                        label="Password"
                        placeholder="Enter your password"
                        variant="outlined"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-combobox
                        label=" Select Gender"
                        :items="['Male', 'Female', 'Others']"
                        variant="outlined"
                        v-model="editedUser.gender"
                      ></v-combobox>
                    </v-col>

                    <v-col cols="12" sm="6">
                      <v-combobox
                        v-model="editedUser.roles"
                        :items="['Manager', 'Employee']"
                        label="Select  role"
                        variant="outlined"
                        :return-object="false"
                      ></v-combobox>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
              <small class="div">*indicates required field</small> </v-card-text
            ><v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="red"
                style="width: 150px; height: 50px"
                variant="flat"
                @click="closeDialog()"
                class="ms-2"
                >Cancel</v-btn
              >

              <v-btn
                style="width: 150px; height: 50px"
                variant="flat"
                @click="save()"
                class="ms-3"
                color="success"
                >Save</v-btn
              >
            </v-card-actions></v-card
          >
        </v-dialog>
        <v-text-field
          v-model="search"
          prepend-inner-icon="mdi-magnify"
          density="compact"
          label="Search"
          single-line
          flat
          hide-details
          variant="solo-filled"
        ></v-text-field>
      </v-card-title>
      <v-dialog v-model="dialogDelete" max-width="500px">
        <v-card>
          <v-card-title class="font ma-4 pt-6" style="text-align: center"
            >you want to delete this info? 🗑️</v-card-title
          >
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              color="red"
              variant="flat"
              style="width: 150px; height: 50px"
              class="mb-3"
              @click="closeDelete"
              >Cancel</v-btn
            >
            <v-btn
              color="success"
              variant="flat"
              style="width: 150px; height: 50px"
              class="mb-3"
              @click="deleteItemConfirm"
              >OK</v-btn
            >
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </div>
    <div>
      <v-data-table
        v-model:page="page"
        :headers="headers"
        :items="filteredUsers"
        :items-per-page="itemsPerPage"
      >
        <template v-slot:bottom>
          <div class="text-center pt-2">
            <v-pagination v-model="page" :length="pageCount"></v-pagination>
          </div>
        </template>

        <template v-slot:[`item.actions`]="{ item }">
          <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
          <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
        </template>
      </v-data-table>
    </div>
  </div>
</template>

<style scoped>
div {
  font-family: 'Kanit';
}
</style>
